/*
 * TremoloPotentialFileParser.hpp
 *
 *  Created on: Mar 9, 2016
 *      Author: heber
 */


#ifndef TREMOLOPOTENTIALFILEPARSER_HPP_
#define TREMOLOPOTENTIALFILEPARSER_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <istream>
#include <set>

#include "Potentials/TremoloPotentialTypes.hpp"

/** This structure is a case for some static functions to parse Particles
 * and EmpiricalPotentials from TREMOLO potentials files.
 */
struct TremoloPotentialFileParser
{
  typedef std::set<TremoloPotentialTypes::tokentype_t> allowed_types_t;

  /** Parse Particle records from a given \a _stream.
   *
   * \param _stream stream to parse from
   * \return true - streaming successful, else - failure
   */
  static bool parseParticles(std::istream &_stream);

  /** Parse EmpiricalPotential records from a given \a _stream.
   *
   * \param _stream stream to parse from
   * \return true - streaming successful, else - failure
   */
  static bool parsePotentials(std::istream &_stream);
};


#endif /* TREMOLOPOTENTIALFILEPARSER_HPP_ */
